# sns – Send Amazon Simple Notification Service messages

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Sends a notification to a topic on your Amazon SNS account.

## Requirements

The below requirements are needed on the host that executes this module.

- boto
- boto3
- botocore
- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
application - added in 2.8 |  | Message to send to application subscriptions
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key

debug_botocore_endpoint_logs
boolean
added in 2.8

Choices:
- no ←
- yes

Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.

ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
email - |  | Message to send to email subscriptions.
email_json - added in 2.8 |  | Message to send to email-json subscriptions
http - |  | Message to send to HTTP subscriptions
https - |  | Message to send to HTTPS subscriptions
lambda - added in 2.8 |  | Message to send to Lambda subscriptions
message_attributes - |  | Dictionary of message attributes. These are optional structured data entries to be sent along to the endpoint. This is in AWS's distinct Name/Type/Value format; see example below.

message_structure
-

Choices:
- json ←
- string

The payload format to use for the message.
This must be 'json' to support protocol-specific messages (`http`, `https`, `email`, `sms`, `sqs`). It must be 'string' to support message_attributes.

msg - / required |  | Default message for subscriptions without a more specific message. aliases: default
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
sms - |  | Message to send to SMS subscriptions
sqs - |  | Message to send to SQS subscriptions
subject - |  | Message subject
topic - / required |  | The name or ARN of the topic to publish to.

validate_certs
boolean

Choices:
- no
- yes ←

When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`
- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html
- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    - name: Send default notification message via SNS
      sns:
        msg: '{{ inventory_hostname }} has completed the play.'
        subject: Deploy complete!
        topic: deploy
      delegate_to: localhost

    - name: Send notification messages via SNS with short message for SMS
      sns:
        msg: '{{ inventory_hostname }} has completed the play.'
        sms: deployed!
        subject: Deploy complete!
        topic: deploy
      delegate_to: localhost

    - name: Send message with message_attributes
      sns:
        topic: "deploy"
        msg: "message with extra details!"
        message_attributes:
          channel:
            data_type: String
            string_value: "mychannel"
          color:
            data_type: String
            string_value: "green"
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
message_id string | when success | The message ID of the submitted message Sample: 2f681ef0-6d76-5c94-99b2-4ae3996ce57b
msg string | always | Human-readable diagnostic information Sample: OK

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Michael J. Schultz (@mjschultz)
- Paul Arthur (@flowerysong)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.